stages: 
  - handoff
  - validate
  - build   # should never have jobs, just for deploy include
  - review  # should never have jobs, just for deploy include
  - test    # should never have jobs
  - gate1 
  - deploy  # dummy stage to follow the template guidelines
  - staging
  - gate2
  - canary  # should never have jobs
  - production
  - incremental rollout 10% # should never have jobs
  - incremental rollout 25% # should never have jobs
  - incremental rollout 50% # should never have jobs
  - incremental rollout 100% # should never have jobs
  - performance  # should never have jobs
  - cleanup 

image: alpine:latest

include:
  - template: Jobs/Deploy.gitlab-ci.yml
  - template: 'Workflows/Branch-Pipelines.gitlab-ci.yml'

variables:
  CANARY_ENABLED: "false" # This plus the next one makes production_manual run
  STAGING_ENABLED: "false" # this plus the previous one makes production_manual run
  DOCKER_DRIVER: overlay2
  ROLLOUT_RESOURCE_TYPE: deployment
  DOCKER_TLS_CERTDIR: ""  # https://gitlab.com/gitlab-org/gitlab-runner/issues/4501

get handoff:
  stage: handoff
  script:
    - cat handoff.env
  artifacts: 
    paths:
      - handoff.env
    reports:
      dotenv: handoff.env

validation job 1:
  stage: validate
  script: 
    - echo "kubernetes image tag = ${CI_APPLICATION_REPOSITORY}:${CI_APPLICATION_TAG}"
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: never
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'
      when: on_success

validation job 2:
  stage: validate
  script: 
    - echo "validation job 2 succeeded"
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: never
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'
      when: on_success

cm staging: 
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-deploy-image:v0.17.2"
  stage: staging
  script:
    - echo ${CI_APPLICATION_REPOSITORY}:${CI_APPLICATION_TAG}
    - auto-deploy check_kube_domain
    - auto-deploy download_chart
    - auto-deploy ensure_namespace
    - auto-deploy initialize_tiller
    - auto-deploy create_secret
    - auto-deploy deploy 
    - auto-deploy persist_environment_url
  environment:
    name: staging/$CI_COMMIT_REF_NAME
    url: http://$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.$KUBE_INGRESS_BASE_DOMAIN
    on_stop: cm_stop_staging
  artifacts:
    paths: [environment_url.txt, tiller.log]
  rules:
    - if: '$CI_KUBERNETES_ACTIVE == null || $CI_KUBERNETES_ACTIVE == ""'
      when: never
    - if: '$CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH'
      when: on_success
  needs:
    - 'get handoff'

production_manual:
  dependencies: [ 'get handoff' ]
  rules: 
    - if: '$CI_KUBERNETES_ACTIVE == null || $CI_KUBERNETES_ACTIVE == ""'
      when: never
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: on_success
    - when: never

cm_stop_staging:
  extends: .auto-deploy
  stage: cleanup
  variables:
    GIT_STRATEGY: none
  script:
    - auto-deploy initialize_tiller
    - auto-deploy delete
  environment:
    name: staging/$CI_COMMIT_REF_NAME
    action: stop
  dependencies: []
  allow_failure: true
  rules:
    - if: '$CI_KUBERNETES_ACTIVE == null || $CI_KUBERNETES_ACTIVE == ""'
      when: never
    - if: '$CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH'
      when: manual

# Jobs to kill 

staging:
  rules:
    - when: never
  dependencies: []

review:
  rules:
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'
      when: never
  dependencies: []

stop_review:
  rules:
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'
      when: never
  dependencies: []

canary:
  rules:
    - if: '$CANARY_ENABLED'
      when: never
  dependencies: []
